#include "rwconfig.h"
#include "skin.h"
#include "reciteword.h"
#include <cstdio>
#include <sys/stat.h>
#include <cstring>

extern CReciteWord *g_pReciteWord;

ConfigFile *usercfgfile = NULL;

static void
conf_init ()
{
	struct stat st;
	FILE *file;
	gchar rw_dir[256];

	strcpy (rw_dir, "users");
	if (stat (rw_dir, &st))
	{
#ifdef G_OS_WIN32
		if (mkdir (rw_dir))
#else
		if (mkdir (rw_dir, 00755))
#endif
		{
			g_print ("Created directory: %s error!\n", rw_dir);
			return;
		}
	}
	strcpy (rw_dir, "users" G_DIR_SEPARATOR_S "default");
	if (stat (rw_dir, &st))
	{
#ifdef G_OS_WIN32
		if (mkdir (rw_dir))
#else		
		if (mkdir (rw_dir, 00755))
#endif			
		{
			g_print ("Created directory: %s error!\n", rw_dir);
			return;
		}
	}

	strcpy (rw_dir, "users" G_DIR_SEPARATOR_S "reciteword.cfg");
	if (stat (rw_dir, &st))
	{
		if ((file = fopen (rw_dir, "w")) == NULL)
			return;
		fprintf (file, "[reciteword]\nuser=default\n");
		
		fclose (file);
	}
}

static void
user_init (gchar * user_file)
{
	struct stat st;
	FILE *file;
	if (stat (user_file, &st))
	{
		if ((file = fopen (user_file, "w")) == NULL)
			return;
		fprintf (file,"[reciteword]\nskin=rw\n");
		fprintf (file,"[chooseword]\ndisorder=1\n");
		fprintf (file,"[firstrecite_group]\ndisorder=1\n");
		fprintf (file,"[firstrecite_skim]\nreadword=1\nshowphonetic=1\nshowmeanlater=1\n");
		fprintf (file,"[firstrecite_test]\nshowmean_1=1\nreadword_1=1\nsndeffect_1=1\nshowmean_2=1\nsndeffect_2=1\n");
		fprintf (file,"[revise_group]\ndisorder=1\n");
		fprintf (file,"[revise_test]\nshowmean_1=1\nreadword_1=1\nshowphonetic_1=1\nsndeffect_1=1\nshowmean_2=1\nsndeffect_2=1\n");
		fprintf (file,"[revise_skim]\nreadword=1\nshowmean=1\nanimate=1\n");
		fprintf (file,"[shooting]\nreadword=1\nshowword=1\nshotsnd=1\n");
		fprintf (file,"[typing]\nreadword=1\nshowmean=1\nsndeffect=1\nshowfingering=1\n");
		fclose (file);
	}
}

int
conf_load_user (gboolean onlyshowdict)
{
	ConfigFile *cfgfile;
	gchar *ab, str[256], str2[256];

	conf_init ();
	cfgfile = rw_cfg_open_file ("users"G_DIR_SEPARATOR_S"reciteword.cfg");
	if (!cfgfile)
	{
		g_print ("load users/reciteword.cfg file error\n");
		return TRUE;
	}
	if (rw_cfg_read_string (cfgfile, "reciteword", "user", &ab))
	{
		strcpy (str, ab);
		g_free (ab);
		if (str[0] == '\0')
			strcpy (str, "default");
	}
	else
	{
		strcpy (str, "default");
	}
	rw_cfg_free (cfgfile);
	g_free (cfgfile);


	sprintf (str2, "users"G_DIR_SEPARATOR_S"%s"G_DIR_SEPARATOR_S"my.cfg", str);
	user_init (str2);
	usercfgfile = rw_cfg_open_file (str2);
	if (!usercfgfile)
	{
		g_print ("load %s file error\n", str2);
		return TRUE;
	}

	if (rw_cfg_read_string (usercfgfile, "reciteword", "skin", &ab))
	{
		strcpy (str, ab);
		g_free (ab);
		if (str[0] == '\0')
			strcpy (str, "rw");
	}
	else
	{
		strcpy (str, "rw");
	}
	if (skin_load_info (str))
	{
		if (strcmp (str, "rw") == 0)
		{
			rw_cfg_free (usercfgfile);
			g_free (usercfgfile);
			usercfgfile = NULL;
			return TRUE;
		}
		else
		{
			if (skin_load_info ("rw"))
			{
				rw_cfg_free (usercfgfile);
				g_free (usercfgfile);
				usercfgfile = NULL;
				return TRUE;
			}
			else
			{
				gtk_rc_parse ("skins"G_DIR_SEPARATOR_S"rw"G_DIR_SEPARATOR_S"gtkrc");
			}
		}
	}
	else
	{
		sprintf (str2, "skins"G_DIR_SEPARATOR_S"%s"G_DIR_SEPARATOR_S"gtkrc", str);
		gtk_rc_parse (str2);
	}
	if (onlyshowdict)
		return FALSE;
	if (rw_cfg_read_string (usercfgfile, "reciteword", "book_file", &ab))
	{
		g_pReciteWord->load_book(ab);
		g_free (ab);
	}
	
	return FALSE;
}
